﻿using MVCSampleBrowser.Models;
using Syncfusion.JavaScript.DataSources;
using System;
using System.Collections;
using System.Collections.Generic;
using System.Linq;
using Syncfusion.Linq;
using System.Web;
using System.Web.Mvc;
using Syncfusion.JavaScript.Models;
using System.Web.Script.Serialization;
using System.Reflection;
using System.Configuration;
using System.Data;
using System.Data.SqlClient;
using Syncfusion.JavaScript;
using System.Drawing;
using Syncfusion.EJ.Export;
using Syncfusion.XlsIO;

namespace MvcApplication66.Controllers
{
    public class HomeController : Controller
    {
        public static List<Orders> order = new List<Orders>();
        public static List<Column> cols = new List<Column>();
        public ActionResult Index()
        {
            if (order.Count == 0)
            {
                BindDataSource();
            }
            ViewBag.data = order;

            /* Add Grid Columns
             * intial Load of the Page
             * Save it in Global and static Variable
             * Assign them to ViewBag
             */
            cols.Add(new Column() { Field = "OrderID", HeaderText = "Order ID" });
            cols.Add(new Column() { Field = "CustomerID", HeaderText = "Order ID" });
            cols.Add(new Column() { Field = "EmployeeID", HeaderText = "Order ID" });
            cols.Add(new Column() { Field = "Freight", HeaderText = "Order ID" });
            ViewBag.columns = cols;

            return View();
        }
        private void BindDataSource()
        {
            int code = 10000;
            for (int i = 1; i < 10; i++)
            {
                order.Add(new Orders(code + 1, 11, 1, 2.3 * i, new DateTime(1991, 05, 15), "Berlin"));
                order.Add(new Orders(code + 2, 22, 2, 3.3 * i, new DateTime(1990, 04, 04), "Madrid"));
                order.Add(new Orders(code + 3, 33, 3, 4.3 * i, new DateTime(1957, 11, 30), "Cholchester"));
                order.Add(new Orders(code + 4, 44, 4, 5.3 * i, new DateTime(1930, 10, 22), "Marseille"));
                order.Add(new Orders(code + 5, 55, 5, 6.3 * i, new DateTime(1953, 02, 18), "Tsawassen"));
                order.Add(new Orders(code + 6, 66, 6, 6.3 * i, new DateTime(1953, 02, 18), "Tsawassen"));
                order.Add(new Orders(code + 7, 77, 7, 6.3 * i, new DateTime(1953, 02, 18), "Tsawassen"));
                order.Add(new Orders(code + 8, 88, 8, 6.3 * i, new DateTime(1953, 02, 18), "Tsawassen"));
                order.Add(new Orders(code + 9, 99, 9, 6.3 * i, new DateTime(1953, 02, 18), "Tsawassen"));
            }
        }
        public void addColumns(GridProperties gridObj){
            if (cols.Count == gridObj.Columns.Count)
                cols.Add(new Column() { Field = "ShipCity", HeaderText = "Ship City" });
            gridObj.Columns = cols;
        }
        public void ExportToExcel(string GridModel)
        {

            ExcelExport exp = new ExcelExport();
            var DataSource = order;
            GridProperties obj = ConvertGridObject(GridModel);
            //Push the additiong columns before exporting the Grid.
            addColumns(obj);
            exp.Export(obj, DataSource, "Export.xlsx", ExcelVersion.Excel2010, false, false, "flat-saffron");
        }
        public void ExportToWord(string GridModel)
        {
            WordExport exp = new WordExport();
            var DataSource = order;
            GridProperties obj = ConvertGridObject(GridModel);
            addColumns(obj);
            exp.Export(obj, DataSource, "Export.docx", false, false, "flat-saffron");
        }
        public void ExportToPdf(string GridModel)
        {
            PdfExport exp = new PdfExport();
            var DataSource = order;
            GridProperties obj = ConvertGridObject(GridModel);
            addColumns(obj);
            exp.Export(obj, DataSource, "Export.pdf", false, false, "flat-saffron");
        }
        private GridProperties ConvertGridObject(string gridProperty)
        {
            JavaScriptSerializer serializer = new JavaScriptSerializer();
            IEnumerable div = (IEnumerable)serializer.Deserialize(gridProperty, typeof(IEnumerable));
            GridProperties gridProp = new GridProperties();
            foreach (KeyValuePair<string, object> ds in div)
            {
                var property = gridProp.GetType().GetProperty(ds.Key, BindingFlags.Instance | BindingFlags.Public | BindingFlags.IgnoreCase);
                if (property != null)
                {
                    Type type = property.PropertyType;
                    string serialize = serializer.Serialize(ds.Value);
                    object value = serializer.Deserialize(serialize, type);
                    property.SetValue(gridProp, value, null);
                }
            }
            return gridProp;
        }
        public class Orders
        {
            public Orders()
            {

            }
            public Orders(long OrderId, int CustomerId, int EmployeeId, double Freight, DateTime OrderDate, string ShipCity)
            {
                this.OrderID = OrderId;
                this.CustomerID = CustomerId;
                this.EmployeeID = EmployeeId;
                this.Freight = Freight;
                this.OrderDate = OrderDate;
                this.ShipCity = ShipCity;
            }
            public long OrderID { get; set; }
            public int CustomerID { get; set; }
            public int EmployeeID { get; set; }
            public double Freight { get; set; }
            public DateTime OrderDate { get; set; }
            public string ShipCity { get; set; }
        }
    }
}